<?php

namespace Drupal\fam_registration\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Attribute for registration welcome plugins.
 *
 * Plugin Namespace: Plugin\FamWelcome.
 *
 * @see \Drupal\Component\Plugin\Attribute\Plugin
 * @see \Drupal\fam_registration\Plugin\WelcomeInterface
 * @see \Drupal\fam_registration\Plugin\WelcomePluginManager
 *
 * @ingroup fam_registration_welcome_plugins
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class FamWelcome extends Plugin {

  /**
   * Creates a new attribute for class discovery and providing the definition.
   *
   * @param string $id
   *   The plugin definition.
   * @param \Stringable|string $label
   *   The display label for this welcome plugin.
   * @param class-string|null $deriver
   *   A plugin definition deriver if provided.
   */
  public function __construct(
    public readonly string $id,
    public readonly \Stringable|string $label,
    public readonly ?string $deriver = NULL,
  ) {}

}
