<?php

namespace Drupal\fam\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Plugin attribute for supporting FAM authentication handlers.
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class FamAuthHandler extends Plugin {

  /**
   * Creates a new instance of the FAM authentication plugin attribute.
   *
   * @param string $id
   *   The plugin identifier.
   * @param \Stringable|string $label
   *   The plugin label and friendly human name.
   * @param int $priority
   *   The weight to sort the precedence of the authentication provider.
   * @param string|null $deriver
   *   Plugin deriver class.
   */
  public function __construct(
    public readonly string $id,
    public readonly \Stringable|string $label,
    public int $priority = 0,
    public ?string $deriver = NULL,
  ) {}

}
